const libs = `${process.cwd()}/libs`;
const log = require(`${libs}/log`)(module);
const xml = require('js2xmlparser');

/**
 * Custom generic middleware used to send api responses
 * @param  {string} value text to be used in the xml response
 */
function response(value) {
    return (req, res, next) => {
        log.debug(req.query.format);
        if (req.query.format === 'csv') {
            res.csv(req.result);
        } else if (req.query.format === 'xml') {
            res.send(xml('result', JSON.stringify({ [value]: req.result })));
        } else {
            res.json({ result: req.result });
        }
    };
}

module.exports = response;
